
local CURRENT_MODULE_NAME = ...

cc = cc or {}

-- init base classes
cc.Event      = import(".Event")
cc.Registry   = import(".Registry")
cc.GameObject = import(".GameObject")
cc.EventProxy = import(".EventProxy")

-- init components
local components = {
    "components.behavior.StateMachine",
    "components.behavior.EventProtocol",
}
for i = 1,#components do
	local packageName = components[i]
    cc.Registry.add(import("." .. packageName, CURRENT_MODULE_NAME), packageName)
end