
local crypto = {}

local Base64 = require "base64"
local cryptoLib = require "crypto"
--http://mkottman.github.io/luacrypto/manual.html#introduction

function crypto.encodeBase64(plaintext)
	return Base64.encode(plaintext)
end

function crypto.decodeBase64(ciphertext)
	return Base64.decode(ciphertext)
end

function crypto.md5(input, isRawOutput)
    if type(isRawOutput) ~= "boolean" then isRawOutput = false end
    return cryptoLib.digest("md5", input)
end

function crypto.encrypt(cipher, text, key, iv)
    -- local ciphers = cryptoLib.list("ciphers")
    -- dump(ciphers, "ciphers")
	return cryptoLib.encrypt(cipher, text, key, iv)
end

function crypto.decrypt(cipher, res, key, iv)
	return cryptoLib.decrypt(cipher, res, key, iv)
end

function crypto.pad(data, blockSize)
	if not data then return nil end
	blockSize = blockSize or 16
	local p = blockSize - (#data % blockSize)
	return data..string.rep(string.char(p), p)
end

function crypto.unpad(data)
	local lastchar = string.byte(data, #data)
	local padding = data:sub(#data-lastchar+1)
	for i=1, lastchar do
		if string.byte(padding, i) ~= lastchar then
			return data
		end
	end
	return data:sub(1,#data-lastchar)
end

return crypto

