function table.areTheSame(left, right) -- Modifying lua namespaces like table and string is apparently BAD PRACTICE, but when in rome...
    if left == right then return true end
    if left == nil or right == nil then return false end
    local l_type = type(left)
    if l_type ~= type(right) or l_type ~= 'table' then return false end
    local done = {}
    local everything_is_alright = true
    for k,v in pairs(left) do
        done[k] = true
        if right[k] ~= nil then
            everything_is_alright = table.areTheSame(v, right[k])
            if not everything_is_alright then return false end
        else return false end
    end
    for k,v in pairs(right) do
        if not done[k] then return false end
    end
    return true
end

function table.isEmpty(table) -- Modifying lua namespaces again #YOLO
    if next(table) ~= nil then
        return false
    end
    return true
end

function table.deepcopy(orig) -- #SWAGGGGGG
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[table.deepcopy(orig_key)] = table.deepcopy(orig_value)
        end
        setmetatable(copy, table.deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

function table.getIndices(t)
    local indices = {}
    for k,v in pairs(t) do indices[k] = k end
    return indices
end


function table.deepMerge(old, new)
    if     old == nil 
        or old == new 
        or type(old) ~= type(new) 
        or type(old) ~= 'table' then
        return new
    end
    for k,v in pairs(new) do
        if type(k) == 'number' and type(v) ~= 'table' then
            table.insert(old, v)
        else
            old[k] = table.deepMerge(old[k], v)
        end
    end
    return old
end

function table.contains(t, element)
    if (t ~= nil) and (type(t) == "table") and (element ~= nil) then
        for _, value in pairs(t) do
            if value == element then
                return true
            end
        end
    end
    return false
end

function table.countElements(t)
    local count = 0
    for _ in pairs(t) do count = count + 1 end
    return count
end

function string.startsWith(String,Start)
   return string.sub(String,1,string.len(Start))==Start
end

function string.endsWith(String,End)
   return End=='' or string.sub(String,-string.len(End))==End
end