--- Global configuration file. Copy, customize and store in your
-- project folder as '.luacov' for project specific configuration
-- @class module
-- @name luacov.defaults
return {

  -- default filename to load for config options if not provided
  -- only has effect in 'luacov.defaults.lua'
  ["configfile"] = ".coverage",

  -- filename to store stats collected
  ["statsfile"] = "coverage.stats.out",

  -- filename to store report
  ["reportfile"] = "coverage.report.out",

  -- luacov.stats file updating frequency.
  -- The lower this value - the more frequenty results will be written out to luacov.stats
  -- You may want to reduce this value for short lived scripts (to for example 2) to avoid losing coverage data.
  ["savestepsize"] = 100,

  -- Run reporter on completion? (won't work for ticks)
  runreport = false,

  -- Delete stats file after reporting?
  deletestats = false,
  
  -- Process Lua code loaded from raw strings
  -- (that is, when the 'source' field in the debug info
  -- does not start with '@')
  codefromstrings = false,

  -- Patterns for files to include when reporting
  -- all will be included if nothing is listed
  -- (exclude overrules include, do not include
  -- the .lua extension, path separator is always '/')
  ["include"] = {
  },

  -- Patterns for files to exclude when reporting
  -- all will be included if nothing is listed
  -- (exclude overrules include, do not include
  -- the .lua extension, path separator is always '/')
  ["exclude"] = {
    "coverage$",
    "coverage/reporter$",
    "coverage/defaults$",
    "coverage/runner$",
    "coverage/stats$",
    "coverage/tick$",
  },


}
