List = {}

function List:new ()
	local list = {left = 0, right = -1}

	function list:pushLeft(value)
		self.left = self.left - 1
		self[self.left] = value
	end

	function list:pushRight(value)
		self.right = self.right + 1
		self[self.right] = value
	end

	function list:popLeft()
		if self.left > self.right then error("list is empty") end
		local value = self[self.left]
		self[self.left] = nil
		self.left = self.left + 1
		return value
	end

	function list:popRight()
		if self.left > self.right then error("list is empty") end
		local value = self[self.right]
		self[self.right] = nil
		self.right = self.right - 1
		return value
	end

	function list:peekLeft()
		return self[self.left]
	end

	function list:peekRight()
		return self[self.right]
	end

	function list:count()
		return self.right - self.left + 1
	end

	function list:get(i)
		return self[self.left + i]
	end

	function list:description(htmlFormat)
		local result = ''
		if self:count() < 1 then
			return result
		end
		if htmlFormat then
			result = '<p>'
		end
		for k = self.left, self.right do
			local item = tostring(self[k])
			if htmlFormat then
				result = result..item..'<br/>\n'
			else
				result = result..item..'\n'
			end
		end
		if htmlFormat then
			result = result..'</p>'
		end
		return result
	end

	return list
end

return List