local lod = class("lod")

lod.MAX_LOD_LEVEL = 5;

function lod:init()
    print("LoD Constructor")
    self.lodBuckets = {};
    -- set up the different buckets
    for i=1, lod.MAX_LOD_LEVEL do
        self.lodBuckets[i] = {};
    end;
end;



function lod:setItemLoD(item, lodLevel)
    if (item == nil) then
        print("LoD Attempt to set LoD on a null value");
        return;
    end;
        
    if (lodLevel > self.MAX_LOD_LEVEL) then
        print("LoD Attempt to set LoD level=" .. lodLevel .. " - max=" .. self.MAX_LOD_LEVEL);
        return;
    end;
    print("LoD setItemLoD(" .. lodLevel ..")")

    table.insert(self.lodBuckets[lodLevel], item);
end;


function lod:setLodLevel(lodLevel)
    print("LoD setLodLevel(" .. lodLevel ..")")
    for i=1, self.MAX_LOD_LEVEL do
        local isEnabled = (i <= lodLevel);
        for k, node in pairs(self.lodBuckets[i]) do
            node:setVisible(isEnabled);
        end;
    end;

end;

function lod.Clear()
    self.init()
end;

lod:init();

return lod;
