--activityFeedManager.lua

local M = {}

M.cachedActivityList = {}

function M.init(serverManager)  
	M._serverManager = serverManager
end
------------------------------

function M.addActivity(eventType, eventData, optionalCallback)
	callback = optionalCallback or function() end
    local params = {}
    params["event_type"] = eventType
    params["event_data"] = eventData
    dump(params, "activityFeedManager.addActivity->params")
    M._serverManager.performRequest("ActivityAdd", params, nil, callback, true)	
end
------------------------------

function M.getActivityList(limitCount, limitDays, listUsers, callback)
    local function getActivityListResult(result, data)
        if result then
            if result.code == runaway.PluginResult.kSucceed then
                M.cacheAndSendBackActivityList(result, data, callback)
            else
                echoInfo("getActivityList failure")
            end
        else
            echoInfo("getActivityList no result")
        end
    end
    local params = {}
    params["limit_count"] = limitCount
    params["limit_days"] = limitDays
    params["list_users"] = listUsers
    dump(params, "activityFeedManager.getActivityFeed->params")
    M._serverManager.performRequest("ActivityList", params, nil, getActivityListResult, true)	
end
------------------------------

function M.cacheAndSendBackActivityList(result, data, callback)
    M.cachedActivityList = data
    callback(result, data)
end
------------------------------

function M.getCachedActivityList()
    return M.cachedActivityList
end
------------------------------

return M

