local M = {}
local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
function M.sendCallback(callback, info)
   local event = cc.EventCustom:new(callback)
   event.info = info
   eventDispatcher:dispatchEvent(event)
end
------------------------------

function M.listenForCallback(callback, handler)
	local listener
	if handler == "" then
		echoError("Empty callback name")
	end
	local function runHandler(event)
		handler(event)
	end
	listener = cc.EventListenerCustom:create(callback, runHandler)
	eventDispatcher:addEventListenerWithFixedPriority(listener, 1)
	return listener
end
------------------------------

function M.stopListeningForCallback(listener)
	eventDispatcher:removeEventListener(listener)
end
------------------------------

return M

