local crashManager = {}

crashManager.crashReporter = {}

function crashManager.init()
    echoInfo("crashManager.init()")
    if runaway.GameConfig:isRelease() then
    	local crashReporter = pluginManager:loadPlugin("CrashReportingCrittercism")
        if crashReporter ~= nil then
            crashReporter:setDebugMode(false)
            echoInfo("Crittercism set up!")
            table.insert(crashManager.crashReporter,crashReporter)
        else
            echoInfo("Crittercism plugin not available!")
        end
    end
end

function crashManager.leaveBreadcrumb(breadcrumb)
    for k = 1,#crashManager.crashReporter do
        local reporter = crashManager.crashReporter[k]
        reporter:leaveBreadcrumb(breadcrumb)
    end
end

function crashManager.setMetadata(key, value)
    for k = 1,#crashManager.crashReporter do
        local reporter = crashManager.crashReporter[k]
        reporter:setUserMetadata(key, value)
    end
end

function crashManager.testCatastrophicCrash()
    for k = 1,#crashManager.crashReporter do
        local reporter = crashManager.crashReporter[k]
        reporter:callFuncWithParam("crash", {})
    end
end

return crashManager