-- metadataManager.lua

local metadataManager = {}

local launchMetadata

function metadataManager.init( metaData )
    if metaData ~= "{}" then 
        metadataManager.onOpenURL(metaData)
    end
    callbackManager.listenForCallback(APP_OPEN_URL, metadataManager.onOpenURL)
end

function metadataManager.onOpenURL(event)
    echoInfo("metadataManager.onOpenURL()")

    local resultTable = {}
    if type(event) == "string" then
        resultTable = json.decode(event) --Try decoding json
        if resultTable == nil then
            resultTable.openURL = event
        end
    else
        local resultString = event:getUserDataString()
        resultTable = json.decode(resultString)
    end

    --TODO Only check result if for com.runawayplay.flutter, ignore fb420249398072062

    dump(resultTable, "resultTable")
    --[[
    "resultTable" = {
[LUA-print] -     "openURL"           = "com.runawayplay.flutter://com.runawayplay.flutter?test=true"
[LUA-print] -     "sourceApplication" = "com.dena.west.Splash.dev.Test-App"
[LUA-print] - }
    ]]

    local query
    string.gsub(resultTable.openURL, "%?(.*)", function(q)
        query = q
        return ""
    end)

    if query ~= nil then
        local values = {}
        for key, value in string.gmatch(query, "([^&=]+)=([^&=]*)&?" ) do
            print( ("key=%s, value=%s"):format(key, value) )
            values[key] = value
        end

        launchMetadata = values

        local event = cc.EventCustom:new(EVENT_METADATA_RECEIVED)
        eventDispatcher:dispatchEvent(event)
    end
end

function metadataManager.getMetadata()
    if launchMetadata == {} then return nil end
	return launchMetadata
end

function metadataManager.clearMetadata()
    launchMetadata = nil
end

return metadataManager