local M = {}
M.attribution = nil

EVENT_ADJUST_ATTRIBUTION_CHANGED =  "AdjustAttributionChanged"

function M.init(devInfo, pluginManager)
	M.adsAdjust = pluginManager:loadPlugin("AdsAdjust")
	if M.adsAdjust ~= nil then
	end

	M.analyticsAdjust = pluginManager:loadPlugin("AnalyticsAdjust")
	if M.analyticsAdjust ~= nil then

		local attribution = M.analyticsAdjust:callStringFuncWithParam("getAttributionData", {})
		if attribution ~= "" then 
	        M.onAttribution(attribution)
	    end
	    callbackManager.listenForCallback(EVENT_ADJUST_ATTRIBUTION_CHANGED, M.onAttribution)
	end


end

function M.onAttribution(event)

	echoInfo("Adjust.onAttribution()")

    local resultTable = {}
    if type(event) == "string" then
        resultTable = json.decode(event) --Try decoding json
    else
        local resultString = event:getUserDataString()
        resultTable = json.decode(resultString)
    end

    dump(resultTable, "resultTable") -- { "adgroup"= "(null)", "campaign" = "(null)", "clickLabel" = "(null)", "creative" = "(null)", "network" = "Organic" ,"trackerName"  = "Organic", "trackerToken" = "zex7qh"}
    M.attribution = resultTable
    platformUserGameData.setData("attribution", resultTable)

	if M.attribution ~= nil and M.attribution.trackerToken ~= nil and omniataPlugin ~= nil then
		local trackAdvertisedIdData = {}
		trackAdvertisedIdData.adjust = M.attribution.trackerToken
	    omniataPlugin.trackAdvertiserID(trackAdvertisedIdData)
	end
end

function M.logEvent(token, partnerParams, callbackParams)
	echoInfo("Adjust logEvent:%s", token)
    if M.analyticsAdjust ~= nil then
    	M.analyticsAdjust:logEvent(token, {partnerParams=json.encode(partnerParams), callbackParams=json.encode(callbackParams)})
	end
end

function M.sendIap(price, currency, token, receiptData, transactionId)
	echoInfo("Adjust sendIap:%s", token)
    if M.analyticsAdjust ~= nil then
	    M.analyticsAdjust:callFuncWithParam("logIAP", {tostring(price), currency, token, receiptData, transactionId})
	end
end

function M.getToken()
	return M.analyticsAdjust:callStringFuncWithParam("getAttributionToken", {})
end

function M.getClickLink()
	return M.analyticsAdjust:callStringFuncWithParam("getAttributionClickLabel", {})
end

return M