local M = {}

M.analyticsFirebase = nil

function M.init()
	-- echoInfo("\n\n\n\n######## FIREBASE #######")
	-- echoInfo("Loading Firebase Lua Plugin")
	M.analyticsFirebase = pluginManager:loadPlugin("AnalyticsFirebase")

	if M.analyticsFirebase == nil then 
		echoInfo("Firebase Analytics plugin is broken.") return end
	    M.analyticsFirebase:configDeveloperInfo({})
	-- echoInfo("######## FIREBASE #######\n\n\n\n")
end

function M.setUserIdentifier(userId)
	-- echoInfo("\n\n\n\n######## FIREBASE #######")
	-- echoInfo("Setting uid in Firebase: " .. userId)
	if M.analyticsFirebase ~= nil then
		M.analyticsFirebase:callFuncWithParam("setUserIdentifier", {tostring(userId)})
	end
end

function M.trackLoadEvent(data)
	-- echoInfo("\n\n\n\n######## FIREBASE #######")
	-- echoInfo("Firebase.trackLoadEvent")
	if M.analyticsFirebase ~= nil then
		M.analyticsFirebase:callFuncWithParam("trackLoadEvent", {json.encode(data)})
	end
end

function M.deGhost(new_uid)
	-- echoInfo("\n\n\n\n######## FIREBASE #######")
	-- echoInfo("Firebase deghost called")
	M.setUserIdentifier(new_uid)
	
end

function M.sendEvent(eventName, data)
    -- echoInfo("\n\n\n\n######## FIREBASE #######")
    -- echoInfo("Sending Firebase event: " .. eventName)
    M.logEvent(eventName, data)
end

function M.trackAdvertiserID(data)
	-- echoInfo("\n\n\n\n######## FIREBASE #######")
	-- echoInfo("Firebase.trackAdvertiserID ")
	if M.analyticsFirebase ~= nil then
		M.analyticsFirebase:callFuncWithParam("trackAdvertiserID", {json.encode(data)})
	end
	-- echoInfo("######## FIREBASE #######\n\n\n\n")
end

function M.sendIap(result, product, qty, price, currency, analyticData, extraData)
    --echoInfo("\n\n\n\n######## FIREBASE #######")
    --echoInfo("Firebase send IAP " .. product)
	if M.analyticsFirebase ~= nil then
		-- This is too much for firebase (limit 100 chars):
		--data = {result = result, product = product, qty = qty, price = price, currency = currency, analyticData = analyticData, extraData = extraData}
		-- Maybe this?
		data = {["result"] = result, ["product"] = product, ["qty"] = qty, ["price"] = price}
		M.analyticsFirebase:callFuncWithParam("logIAP", {json.encode(data)})
	end
end

function M.getChannelMessages(channelId, callback)
	--echoInfo("\n\n\n\n######## FIREBASE #######")
	--echoInfo("Channel messages not supported by Firebase")
end

function M.enablePushNotification()
	--echoInfo("\n\n\n\n######## FIREBASE #######")
	--echoInfo("enablePushNotification: not supported by Firebase")
end

function M.disablePushNotifications()
	--echoInfo("\n\n\n\n######## FIREBASE #######")
	--echoInfo("disablePushNotification: not supported by Firebase")
end

function M.logEvent(eventName, data)
	-- echoInfo("\n\n\n\n######## FIREBASE #######")
	if M.analyticsFirebase ~= nil then
		--M.analyticsFirebase:callFuncWithParam("logEvent", {eventName, data})
		M.analyticsFirebase:logEvent(eventName, data)
	end
end


return M
