local M = {}

M.plugins = {}

function M.init()
	if device.client_platform ~= "amazon" then
	    table.insert(M.plugins, require(cc.PACKAGE_NAME .. ".plugins.firebase"))
    end
    
	for k = 1, #M.plugins do
		M.plugins[k].init()
	end
end

function M.setUserIdentifier(userId)
	for k = 1, #M.plugins do
		M.plugins[k].setUserIdentifier(userId)
	end
end

function M.trackLoadEvent(data)
	for k = 1, #M.plugins do
		M.plugins[k].trackLoadEvent(data)
	end
end

function M.deGhost(new_uid)
	for k = 1, #M.plugins do
		M.plugins[k].deGhost(new_uid)
	end
end

function M.sendEvent(name, data)
	for k = 1, #M.plugins do
		M.plugins[k].sendEvent(name, data)
	end
end

function M.trackAdvertiserID(data)
	for k = 1, #M.plugins do
		M.plugins[k].trackAdvertiserID(data)
	end
end

function M.sendIap(result, product, qty, price, currency, analyticData, extraData)
	for k = 1, #M.plugins do
		M.plugins[k].sendIap(result, product, qty, price, currency, analyticData, extraData)
	end
end

function M.getChannelMessages(channelId, callback)
	for k = 1, #M.plugins do
		M.plugins[k].getChannelMessages(channelId, callback)
	end
end

function M.enablePushNotification()
	for k = 1, #M.plugins do
		M.plugins[k].enablePushNotification()
	end
end

function M.disablePushNotifications()
	for k = 1, #M.plugins do
		M.plugins[k].disablePushNotifications()
	end
end

function M.logEvent(eventName, data)
	for k = 1, #M.plugins do
		M.plugins[k].logEvent(eventName, data)
	end
end

return M
