local SocialService = class("SocialService")

function SocialService:ctor()
	echoInfo("SocialService:ctor()")
end

function SocialService:init(devInfo)
	echoInfo("SocialService:init()")
end

function SocialService:isAvailable()
	return false
end

function SocialService:login(params, callback)
end

function SocialService:isLogined()
	return false
end

function SocialService:logout(callback)
end

function SocialService:getAccessToken()
end

function SocialService:getProfile(callback)
end

function SocialService:getImage(callback)
end

function SocialService:friendsAvail()
	return false
end

function SocialService:getImageForFriend(friend, callback)
	if friend.picUrl then
	    local reqUrl = friend.picUrl
		local sharedTextureCache = cc.Director:getInstance():getTextureCache()

		local cachedImage = sharedTextureCache:getTextureForKey(reqUrl)
		if (cachedImage) then
        	local data = {picture = cc.Sprite:createWithTexture(cachedImage)}
            callback({code=0,type='picture',msg='Success!'}, data)
		else
			local function onLocalResponse(result, sprite, req)
		        if result.code == HTTPREQUEST_SUCCESS then
		        	local data = {picture = sprite}
		            callback({code=0,type='picture',msg='Success!'}, data)
		        else
		            echoInfo(result.message)
		            callback({code=2,type='picture',msg='Failure!'}, nil)
		        end
		    end

		    local reqType = HTTPREQUEST_GET_IMAGE
		    local reqTag = "GET profile pic"
		    local req = network.createHTTPRequest(onLocalResponse, reqUrl, reqType, reqTag)
		    network.send(req)
		end
	else
		result = {code=2,type='picture',msg='No profile picture info'}
		callback(result)
	end
end


function SocialService:applyFriendData(friendAccount)
end

function SocialService:getFriends(callback)
end

function SocialService:getFriendForID(params, callback)
end

function SocialService:updateRemote(params, callback)
end

function SocialService:requestAvail()
	return false
end

function SocialService:sendInvite(params, callback)
end

function SocialService:sendRequest(params, callback)
end

function SocialService:postsAvail()
	return false
end

function SocialService:post(params, callback) -- params: name, caption, description, link, picture
end

function SocialService:achievementsAvail()
	return false
end

function SocialService:submitAchievement(achivementInfo, callback)
end

function SocialService:showAchievements()
end

function SocialService:resetAchievements(callback)
end

function SocialService:createAchievementInfo(goal)
	return {
		identifier = goal.testID,
		percentComplete = 100
	}
end

function SocialService:callFuncWithParam(functionName, data, callback)
end

return SocialService